## net.i2p.router.tunnel
Class InboundEndpointProcessor

    java.lang.Object
      net.i2p.router.tunnel.InboundEndpointProcessor

    public class InboundEndpointProcessor

extends java.lang.Object

Receive the inbound tunnel message, removing all of the layers added by earlier hops to recover the preprocessed data sent by the gateway. This delegates the crypto to the OutboundGatewayProcessor, since the tunnel creator does the same thing in both instances.

Field Summary
`(package private) static boolean` `USE_ENCRYPTION`

Constructor Summary
`InboundEndpointProcessor(I2PAppContext ctx, TunnelCreatorConfig cfg)`
`InboundEndpointProcessor(I2PAppContext ctx, TunnelCreatorConfig cfg, IVValidator validator)`

Method Summary
`TunnelCreatorConfig` `getConfig()`
`Hash` `getDestination()`
`boolean` `retrievePreprocessedData(byte[] orig, int offset, int length, Hash prev)` Undo all of the encryption done by the peers in the tunnel, recovering the preprocessed data sent by the gateway.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### USE_ENCRYPTION

    static final boolean USE_ENCRYPTION

See Also:
  Constant Field Values

Constructor Detail

### InboundEndpointProcessor

    public InboundEndpointProcessor(I2PAppContext ctx,
                                    TunnelCreatorConfig cfg)

### InboundEndpointProcessor

    public InboundEndpointProcessor(I2PAppContext ctx,
                                    TunnelCreatorConfig cfg,
                                    IVValidator validator)

Method Detail

### getDestination

    public Hash getDestination()

### getConfig

    public TunnelCreatorConfig getConfig()

### retrievePreprocessedData

    public boolean retrievePreprocessedData(byte[] orig,
                                            int offset,
                                            int length,
                                            Hash prev)

  Undo all of the encryption done by the peers in the tunnel, recovering the preprocessed data sent by the gateway.

  Returns:
    true if the data was recovered (and written in place to orig), false if it was a duplicate or from the wrong peer.